const app = getApp()
import WxValidate from '../../utils/wxValidate'
import { match_project } from '../../utils/dict';
Page({

    /**
     * 页面的初始数据
     */
    data: {
        frameStyle: { useTop: true, name: '添加比赛', leftArrow: true, useBar: false },
        form: {},
        //比赛类型
        typeList: match_project,
        // 用户id
        id: ''
    },
    initValidate() {
        const rules = { name: { required: true }, type: { required: true }, explain: { required: true }, num: { required: true, digits: true } }
        // 验证字段的提示信息，若不传则调用默认的信息
        const messages = { name: { required: '请输入比赛项目名称', }, type: { required: '请选择类型', }, explain: { required: '请输入比赛项目说明', }, num: { required: '请输入比赛人数' } };
        this.WxValidate = new WxValidate(rules, messages)
    },
    // 返回
    back: function () {
        wx.navigateBack({ delta: 1 })
    },
    // 选择类型
    typeChange: function (e) {
        const that = this;
        let index = e.detail.value;
        let value = that.data.typeList[index];
        that.setData({ 'form.type': value.value });
    },
    // 提交登录
    onSubmit: async function (e) {
        const that = this;
        const params = e.detail.value;
        params.num = parseFloat(params.num);
        const data = that.data.form;
        if (!this.WxValidate.checkForm(params)) {
            const error = this.WxValidate.errorList[0];
            wx.showToast({ title: `${error.msg}`, icon: 'error', duration: 2000 })
            return false
        } else {
            let arr;
            if (data._id) {
                arr = await app.$post(`/newCourt/api/matchProject/${data._id}`, params);
                if (arr.errcode == '0') { wx.showToast({ title: `维护信息完成`, icon: 'success', duration: 2000 }); that.back(); }
                else wx.showToast({ title: `${error.msg}`, icon: 'error', duration: 2000 })
            } else {
                arr = await app.$post(`/newCourt/api/matchProject`, params);
                if (arr.errcode == '0') { wx.showToast({ title: `添加信息完成`, icon: 'success', duration: 2000 }); that.back(); }
                else wx.showToast({ title: `${error.msg}`, icon: 'error', duration: 2000 })
            }
        }
    },
    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        const that = this;
        if (options && options.id) that.setData({ id: options.id })
        //验证规则函数
        that.initValidate();
        // 监听用户是否登录
        that.watchLogin();
    },
    // 监听用户是否登录
    watchLogin: async function () {
        const that = this;
        wx.getStorage({
            key: 'user',
            success: async res => {
                const arr = await app.$get(`/newCourt/api/matchProject/${that.data.id}`);
                if (arr.errcode == '0') {
                    that.setData({ form: arr.data });
                }
            },
            fail: res => {
                wx.redirectTo({ url: '/pages/index/index', })
            }
        })
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {

    }
})